123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297 |
- # ===========================================================================
- # Kernel configuration targets
- # These targets are used from top-level makefile
- PHONY += xconfig gconfig menuconfig config silentoldconfig update-po-config \
- localmodconfig localyesconfig
- ifdef KBUILD_KCONFIG
- Kconfig := $(KBUILD_KCONFIG)
- else
- Kconfig := Kconfig
- endif
- ifeq ($(quiet),silent_)
- silent := -s
- endif
- # We need this, in case the user has it in its environment
- unexport CONFIG_
- xconfig: $(obj)/qconf
- $< $(silent) $(Kconfig)
- gconfig: $(obj)/gconf
- $< $(silent) $(Kconfig)
- menuconfig: $(obj)/mconf
- $< $(silent) $(Kconfig)
- config: $(obj)/conf
- $< $(silent) --oldaskconfig $(Kconfig)
- nconfig: $(obj)/nconf
- $< $(silent) $(Kconfig)
- silentoldconfig: $(obj)/conf
- $(Q)mkdir -p include/config include/generated
- $(Q)test -e include/generated/autoksyms.h || \
- touch include/generated/autoksyms.h
- $< $(silent) --$@ $(Kconfig)
- localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
- $(Q)mkdir -p include/config include/generated
- $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
- $(Q)if [ -f .config ]; then \
- cmp -s .tmp.config .config || \
- (mv -f .config .config.old.1; \
- mv -f .tmp.config .config; \
- $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
- mv -f .config.old.1 .config.old) \
- else \
- mv -f .tmp.config .config; \
- $(obj)/conf $(silent) --silentoldconfig $(Kconfig); \
- fi
- $(Q)rm -f .tmp.config
- # Create new linux.pot file
- # Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
- update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
- $(Q)$(kecho) " GEN config.pot"
- $(Q)xgettext --default-domain=linux \
- --add-comments --keyword=_ --keyword=N_ \
- --from-code=UTF-8 \
- --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
- --directory=$(srctree) --directory=$(objtree) \
- --output $(obj)/config.pot
- $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
- $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
- $(srctree)/arch/*/um/Kconfig`; \
- do \
- $(kecho) " GEN $$i"; \
- $(obj)/kxgettext $$i \
- >> $(obj)/config.pot; \
- done )
- $(Q)$(kecho) " GEN linux.pot"
- $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
- --output $(obj)/linux.pot
- $(Q)rm -f $(obj)/config.pot
- # These targets map 1:1 to the commandline options of 'conf'
- simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
- alldefconfig randconfig listnewconfig olddefconfig
- PHONY += $(simple-targets)
- $(simple-targets): $(obj)/conf
- $< $(silent) --$@ $(Kconfig)
- PHONY += oldnoconfig savedefconfig defconfig
- # oldnoconfig is an alias of olddefconfig, because people already are dependent
- # on its behavior (sets new symbols to their default value but not 'n') with the
- # counter-intuitive name.
- oldnoconfig: olddefconfig
- savedefconfig: $(obj)/conf
- $< $(silent) --$@=defconfig $(Kconfig)
- defconfig: $(obj)/conf
- ifeq ($(KBUILD_DEFCONFIG),)
- $< $(silent) --defconfig $(Kconfig)
- else
- ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
- @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
- $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
- else
- @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
- $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
- endif
- endif
- %_defconfig: $(obj)/conf
- $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
- configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
- %.config: $(obj)/conf
- $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
- $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
- +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
- PHONY += kvmconfig
- kvmconfig: kvm_guest.config
- @:
- PHONY += xenconfig
- xenconfig: xen.config
- @:
- PHONY += tinyconfig
- tinyconfig:
- $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
- # Help text used by make help
- help:
- @echo ' config - Update current config utilising a line-oriented program'
- @echo ' nconfig - Update current config utilising a ncurses menu based'
- @echo ' program'
- @echo ' menuconfig - Update current config utilising a menu based program'
- @echo ' xconfig - Update current config utilising a Qt based front-end'
- @echo ' gconfig - Update current config utilising a GTK+ based front-end'
- @echo ' oldconfig - Update current config utilising a provided .config as base'
- @echo ' localmodconfig - Update current config disabling modules not loaded'
- @echo ' localyesconfig - Update current config converting local mods to core'
- @echo ' silentoldconfig - Same as oldconfig, but quietly, additionally update deps'
- @echo ' defconfig - New config with default from ARCH supplied defconfig'
- @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
- @echo ' allnoconfig - New config where all options are answered with no'
- @echo ' allyesconfig - New config where all options are accepted with yes'
- @echo ' allmodconfig - New config selecting modules when possible'
- @echo ' alldefconfig - New config with all symbols set to default'
- @echo ' randconfig - New config with random answer to all options'
- @echo ' listnewconfig - List new options'
- @echo ' olddefconfig - Same as silentoldconfig but sets new symbols to their'
- @echo ' default value'
- @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
- @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
- @echo ' tinyconfig - Configure the tiniest possible kernel'
- # lxdialog stuff
- check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
- # Use recursively expanded variables so we do not call gcc unless
- # we really need to do so. (Do not call gcc as part of make mrproper)
- HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
- -DLOCALE
- # ===========================================================================
- # Shared Makefile for the various kconfig executables:
- # conf: Used for defconfig, oldconfig and related targets
- # nconf: Used for the nconfig target.
- # Utilizes ncurses
- # mconf: Used for the menuconfig target
- # Utilizes the lxdialog package
- # qconf: Used for the xconfig target
- # Based on Qt which needs to be installed to compile it
- # gconf: Used for the gconfig target
- # Based on GTK+ which needs to be installed to compile it
- # object files used by all kconfig flavours
- lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
- lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
- conf-objs := conf.o zconf.tab.o
- mconf-objs := mconf.o zconf.tab.o $(lxdialog)
- nconf-objs := nconf.o zconf.tab.o nconf.gui.o
- kxgettext-objs := kxgettext.o zconf.tab.o
- qconf-cxxobjs := qconf.o
- qconf-objs := zconf.tab.o
- gconf-objs := gconf.o zconf.tab.o
- hostprogs-y := conf nconf mconf kxgettext qconf gconf
- clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
- clean-files += zconf.tab.c zconf.lex.c zconf.hash.c gconf.glade.h
- clean-files += config.pot linux.pot
- # Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
- PHONY += $(obj)/dochecklxdialog
- $(addprefix $(obj)/,$(lxdialog)): $(obj)/dochecklxdialog
- $(obj)/dochecklxdialog:
- $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
- always := dochecklxdialog
- # Add environment specific flags
- HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
- # generated files seem to need this to find local include files
- HOSTCFLAGS_zconf.lex.o := -I$(src)
- HOSTCFLAGS_zconf.tab.o := -I$(src)
- LEX_PREFIX_zconf := zconf
- YACC_PREFIX_zconf := zconf
- HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
- HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
- HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
- HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
- -Wno-missing-prototypes
- HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
- HOSTLOADLIBES_nconf = $(shell \
- pkg-config --libs menuw panelw ncursesw 2>/dev/null \
- || pkg-config --libs menu panel ncurses 2>/dev/null \
- || echo "-lmenu -lpanel -lncurses" )
- $(obj)/qconf.o: $(obj)/.tmp_qtcheck
- ifeq ($(MAKECMDGOALS),xconfig)
- $(obj)/.tmp_qtcheck: $(src)/Makefile
- -include $(obj)/.tmp_qtcheck
- # Qt needs some extra effort...
- $(obj)/.tmp_qtcheck:
- @set -e; $(kecho) " CHECK qt"; \
- if pkg-config --exists Qt5Core; then \
- cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
- libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
- moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
- elif pkg-config --exists QtCore; then \
- cflags=`pkg-config --cflags QtCore QtGui`; \
- libs=`pkg-config --libs QtCore QtGui`; \
- moc=`pkg-config --variable=moc_location QtCore`; \
- else \
- echo >&2 "*"; \
- echo >&2 "* Could not find Qt via pkg-config."; \
- echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
- echo >&2 "*"; \
- exit 1; \
- fi; \
- echo "KC_QT_CFLAGS=$$cflags" > $@; \
- echo "KC_QT_LIBS=$$libs" >> $@; \
- echo "KC_QT_MOC=$$moc" >> $@
- endif
- $(obj)/gconf.o: $(obj)/.tmp_gtkcheck
- ifeq ($(MAKECMDGOALS),gconfig)
- -include $(obj)/.tmp_gtkcheck
- # GTK+ needs some extra effort, too...
- $(obj)/.tmp_gtkcheck:
- @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
- if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
- touch $@; \
- else \
- echo >&2 "*"; \
- echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
- echo >&2 "*"; \
- false; \
- fi \
- else \
- echo >&2 "*"; \
- echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
- echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
- echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
- echo >&2 "*"; \
- false; \
- fi
- endif
- $(obj)/zconf.tab.o: $(obj)/zconf.lex.c $(obj)/zconf.hash.c
- $(obj)/qconf.o: $(obj)/qconf.moc
- quiet_cmd_moc = MOC $@
- cmd_moc = $(KC_QT_MOC) -i $< -o $@
- $(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
- $(call cmd,moc)
- # Extract gconf menu items for i18n support
- $(obj)/gconf.glade.h: $(obj)/gconf.glade
- $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
- $(obj)/gconf.glade
|